updateUndo				PROTO


LOAD	PROC lpFileName:DWORD

	LOCAL hFile1	:DWORD
	LOCAL FileLen	:DWORD
	LOCAL BytesRead	:DWORD
	LOCAL Buffer	:DWORD

	xor eax,eax
	mov Buffer,eax
	mov FileLen,eax

	invoke CreateFile,lpFileName,GENERIC_READ,eax,eax, \
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,eax
	cmp eax,-1
	jz Return_

	mov hFile1,eax
        invoke GetFileSize,eax,NULL
        mov FileLen,eax
        inc eax
        invoke GlobalAlloc,GMEM_FIXED + GMEM_ZEROINIT,eax
        test eax,eax
        jz CloseFile                            ;jump if not enough memory

        mov Buffer,eax

        invoke ReadFile,hFile1,Buffer,FileLen,addr BytesRead,NULL
        test eax,eax
        jz ReadError
        mov eax,BytesRead
        cmp eax,FileLen
        jz CloseFile

ReadError:
	invoke GlobalFree,Buffer
	mov Buffer,0

CloseFile:
	invoke CloseHandle,hFile1
	Return_:	mov eax,Buffer
	mov edx,FileLen
	ret
LOAD ENDP
SAVE proc lpName:DWORD,lpData:DWORD,fl:DWORD

    LOCAL hOutput:DWORD
    LOCAL bw     :DWORD
    invoke CreateFile,lpName,GENERIC_WRITE,NULL,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
    mov hOutput, eax
    invoke WriteFile,hOutput,lpData,fl,lp bw,NULL
    invoke CloseHandle,hOutput
    mov eax, bw                 ; return written byte count
    ret
SAVE endp

getcurrentoffset proc
mov eax,ScanPos
mov ecx,SelectedColor
shl ecx,1
add eax,ecx
ret
getcurrentoffset endp
ReloadRom				PROTO

ReloadRom proc 
	
	__ LOAD,lp RomFilename
		.if eax
			pushad
			stringfree hRomFile
			popad
			mov hRomFile,eax
			mov Romsize,edx
			call updateUndo
				__ MessageBox,hWnd,"Revert Successful","Information",MB_ICONINFORMATION
			return 1
		.else
			__ MessageBox,hWnd,"Fail to Open file for Reading","Revert Failed",MB_ICONEXCLAMATION
			return-1
		.endif
	
	ret

ReloadRom endp
OpenRom proc 
OpenFileName PROTO :DWORD
		__ OpenFileName,lp RomFilename
		.if eax
			__ LOAD,lp RomFilename
			.if eax
				pushad
				stringfree hRomFile
				popad
				mov hRomFile,eax
				mov Romsize,edx
				call updateUndo
				return 1
			.else
				__ MessageBox,hWnd,"Fail to Open file for Reading","File Open Error",MB_ICONEXCLAMATION
				return-1
			.endif
		.endif
		return -1
OpenRom endp
SaveFileName PROTO :DWORD
.data
firstrun	dd	0
.code

SaveRomFile proc
		__ SaveFileName,lp RomSaveFilename
		.if !eax
			return -1
		.else
			__ SAVE,lp RomSaveFilename,hRomFile,Romsize
			.if firstrun!=0
				__ MessageBox,hWnd,lp RomSaveFilename,"New saving rom set to ...",MB_ICONINFORMATION + MB_OK
			.endif
			inc firstrun
		.endif
		ret
		
SaveRomFile endp

szFSaveTitle db "Save Rom as ...",0
szFOpenTitle db "Open Source Snes Rom ...",0
		szFOpenFilter textequ <SMCFilterString>
		szFSaveFilter textequ <SMCFilterString>
		szDefExt textequ <SMCFilterString>
		
SMCFilterString db "Snes Rom (*.smc)",0,"*.smc",0
		db "All Files (*.*)",0,"*.*",0,0
		
OpenFileName proc lpfName:DWORD
LOCAL ofn :OPENFILENAME
		
LOCAL hFake
		Wipe ofn
		
		mov ofn.lStructSize,sizeof OPENFILENAME
		mov ofn.hWndOwner,NULL
		m2m ofn.hInstance,hInstance
		m2m ofn.lpstrFilter,offset szFSaveFilter
		m2m ofn.lpstrFile,lpfName
		mov ofn.nMaxFile,MAX_PATH
		m2m ofn.lpstrTitle,offset szFOpenTitle
		mov ofn.nMaxFileTitle,sizeof szFOpenTitle
		mov ofn.lpstrDefExt,offset szDefExt
		mov ofn.lpfnHook,offset OFNHookProc
		mov ofn.Flags,OFN_EXPLORER or OFN_LONGNAMES or OFN_NONETWORKBUTTON or OFN_HIDEREADONLY or OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST
		
		invoke GetOpenFileName,addr ofn
		mov ecx,hFake
		test ecx,ecx
		jz @F
		
		push eax
		invoke SetFocus,ecx
		pop eax
		@@:
		ret
OpenFileName endp
		
SaveFileName proc lpfName:DWORD
LOCAL ofn :OPENFILENAME
LOCAL hFake
		Wipe ofn
		
		mov ofn.lStructSize,sizeof OPENFILENAME
		mov ofn.hWndOwner,NULL
		m2m ofn.hInstance,hInstance
		m2m ofn.lpstrFilter,offset szFSaveFilter
		m2m ofn.lpstrFile,lpfName
		mov ofn.nMaxFile,MAX_PATH
		m2m ofn.lpstrTitle,offset szFSaveTitle
		mov ofn.nMaxFileTitle,sizeof szFSaveTitle
		mov ofn.lpstrDefExt,offset szDefExt
		mov ofn.lpfnHook,offset OFNHookProc
		mov ofn.Flags,OFN_EXPLORER or OFN_LONGNAMES or OFN_OVERWRITEPROMPT or \
		OFN_NONETWORKBUTTON or OFN_HIDEREADONLY or OFN_PATHMUSTEXIST or \
		OFN_EXTENSIONDIFFERENT or OFN_ENABLEHOOK
		invoke GetSaveFileName,addr ofn
		mov ecx,hFake
		test ecx,ecx
		jz @F
		
		push eax
		invoke SetFocus,ecx
		pop eax
		@@:
		ret
SaveFileName endp
		
GetPathOnly proc src:DWORD, dst:DWORD

    push esi
    push edi

    xor ecx, ecx    ; zero counter
    mov esi, src
    mov edi, dst

  @@:
    mov al, [esi]   ; read byte from address in esi
    inc esi
    inc ecx         ; increment counter
    cmp al, 0       ; test for zero
    je gfpOut       ; exit loop on zero
    cmp al, "\"     ; test for "\"
    jne nxt1        ; jump over if not
    mov edx, ecx    ; store counter in ecx = last "\" offset in ecx
  nxt1:
    mov [edi], al   ; write byte to address in edi
    inc edi
    jmp @B
    
  gfpOut:
    add edx, dst    ; add destination address to offset of last "\"
    mov [edx], al   ; write terminator to destination

    pop edi
    pop esi

    ret

GetPathOnly endp

updateUndo proc


.if !hUndoFile
	stringalloc Romsize
	mov hUndoFile,eax
.endif
__ RtlMoveMemory,hUndoFile,hRomFile,Romsize

ret

updateUndo endp

OFNHookProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
		.if uMsg==WM_INITDIALOG
			invoke GetParent,hWin
			invoke SetWindowPos,eax,HWND_TOPMOST,0,0,0,0,
			SWP_NOMOVE or SWP_NOSIZE
		.endif
		xor eax,eax
		ret
OFNHookProc endp
		


getoldoffset proc
mov eax,ScanPos
mov ecx,oldColor

shl ecx,1
add eax,ecx
ret
getoldoffset endp
